﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel.Background;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace Background
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();

            this.NavigationCacheMode = NavigationCacheMode.Required;
        }

        private async void OnRegisterBackgroundTaskClicked(object sender, RoutedEventArgs e)
        {
            BackgroundTaskBuilder builder = new BackgroundTaskBuilder();
            builder.Name = "Toast task";
            builder.TaskEntryPoint = "Background.SharedTask.MyBackgroundTask";
            builder.SetTrigger(new TimeTrigger(30, false));
            builder.AddCondition(new SystemCondition(SystemConditionType.InternetAvailable));

            BackgroundAccessStatus status = await BackgroundExecutionManager.RequestAccessAsync();
            if (status != BackgroundAccessStatus.Denied)
            {
                builder.Register();
            }
        }
    }
}
