﻿using System;
using System.Collections.Generic;
using System.Linq;
using Windows.ApplicationModel.Background;
using Windows.Data.Xml.Dom;
using Windows.UI.Notifications;
using Background.SharedTask.Entities;
using Background.SharedTask.Services;

namespace Background.SharedTask
{
    public sealed class MyBackgroundTask : IBackgroundTask
    {
        public async void Run(IBackgroundTaskInstance taskInstance)
        {
            BackgroundTaskDeferral deferral = taskInstance.GetDeferral();
            RssService service = new RssService();
            IEnumerable<FeedItem> news = await service.GetNewsAsync("http://feeds.feedburner.com/qmatteoq_eng");

            XmlDocument toastXml = ToastNotificationManager.GetTemplateContent(ToastTemplateType.ToastText01);
            XmlNodeList toastTextElements = toastXml.GetElementsByTagName("text");
            toastTextElements[0].AppendChild(toastXml.CreateTextNode("Number of news: " + news.Count()));

            ToastNotification notification = new ToastNotification(toastXml);

            ToastNotifier notifier = ToastNotificationManager.CreateToastNotifier();
            notifier.Show(notification);
            deferral.Complete();
        }
    }
}
