﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using System.Xml.Linq;
using Windows.Foundation;
using Background.SharedTask.Entities;

namespace Background.SharedTask.Services
{
    public sealed class RssService
    {
        public IAsyncOperation<IEnumerable<FeedItem>> GetNewsAsync(string url)
        {
            return GetNewsInternal(url).AsAsyncOperation();
        }

        internal async Task<IEnumerable<FeedItem>> GetNewsInternal(string url)
        {
            HttpClient client = new HttpClient();
            string result = await client.GetStringAsync(url);
            var xdoc = XDocument.Parse(result);
            return (from item in xdoc.Descendants("item")
                    select new FeedItem()
                    {
                        Title = (string)item.Element("title"),
                        Description = (string)item.Element("description"),
                        Link = (string)item.Element("link"),
                        PublishDate = DateTime.Parse((string)item.Element("pubDate"))
                    }).ToList();
        }
    }
}
